/** @file
 * @brief  H8/300Hץ൯ưӥƥå׼¹ԡ֥졼ǽ
 *
 * @date	2002.03.22
 * @author	Takashi Shudo
 */

#ifndef _H_task
#define _H_task

#define TRAPA0	0x5700
#define TRAPA1	0x5710
#define TRAPA2	0x5720
#define TRAPA3	0x5730

#define	BREAK_CODE	TRAPA3	//!< ֥졼ѥȥå̿

#define MAXBREAK	8	//!< ǽʺ֥졼ݥȿ

// 桼ץμ¹Ծ(execStat)
#define EXST_RESET	0	//!< ꥻåľ(̤¹)
#define EXST_ASTEP	1	//!< ƥå׼¹Ը
#define EXST_ABREAK	2	//!< ֥졼߸
#define EXST_EXEC	3	//!< ¹(¹ʤΤǥ˥Ǥϸʤ)
#define EXST_ESTEP	4	//!< ƥå׼¹(¹ʤΤǥ˥
				// ϸʤ)
#define EXST_NEXEC	5	//!< ߤPC֥졼äΤǥƥ
				// ׼¹Ըμ¹Ԥ(¹ʤΤǥ
				// Ǥϸʤ)

/**
 * ¹ԥץΤΥ쥸
 */
typedef union {
	unsigned long data[10];
	struct {
		unsigned long r0;
		unsigned long r1;
		unsigned long r2;
		unsigned long r3;
		unsigned long r4;
		unsigned long r5;
		unsigned long r6;
		unsigned long r7;
		unsigned long ccr;
		unsigned long pc;
	} name;
} st_task;

/**
 * ֥졼ݥ
 */
typedef	struct {
	volatile unsigned short	*addr;	//!< ɥ쥹
	volatile unsigned short	code;	//!< Υ
} breakPt;

unsigned char ExecStatus(void);
void ExecUserProgram(void);
void StepExecUserProgram(void);

void DeleteAllBreakpoints(void);
void PrepareBreakpoints(void);
void FinishBreakpoints(void);
void InitUserProgram(void);

#endif // _H_task
