/** @file
 * @brief	H8/300Hץ൯ưӥƥå׼¹ԡ֥졼ǽ
 *
 * @date	2002.03.22
 * @author	Takashi SHUDO
 */

#ifndef _H_task
#define _H_task

#ifdef H8NORMAL
#define DisableSystemIRQ	asm("orc.b #0x80,ccr");	//!< ߶ػ
#define EnableSystemIRQ		asm("andc.b #0x7f,ccr");//!< ߵ
#define ADDR_PRINT_FORMAT	"%04lX"
typedef	unsigned short	INTPOINTER;		//!< Ρޥ⡼ɤΥݥ
#else
// UIӥåȤϳߥޥȤƻ
#define DisableSystemIRQ	asm("orc.b #0x40,ccr");	//!< ߶ػ
#define EnableSystemIRQ		asm("andc.b #0xbf,ccr");//!< ߵ
#define ADDR_PRINT_FORMAT	"%06lX"
typedef	unsigned long	INTPOINTER;		//!< ĥ⡼ɤΥݥ
#endif

#define TRAPA0	0x5700
#define TRAPA1	0x5710
#define TRAPA2	0x5720
#define TRAPA3	0x5730

#define	BREAK_CODE	TRAPA3	//!< ֥졼ѥȥå̿

// 桼ץμ¹Ծ(execStat)
#define EXST_RESET	0	//!< ꥻåľ(̤¹)
#define EXST_ASTEP	1	//!< ƥå׼¹Ը
#define EXST_ABREAK	2	//!< ֥졼߸
#define EXST_EXEC	3	//!< ¹(¹ʤΤǥ˥Ǥϸʤ)
#define EXST_ESTEP	4	//!< ƥå׼¹(¹ʤΤǥ˥
				// ϸʤ)
#define EXST_NEXEC	5	//!< ߤPC֥졼äΤǥƥ
				// ׼¹Ըμ¹Ԥ
				// (¹ʤΤǥ˥Ǥϸʤ)

/**
 * ¹ԥΤΥ쥸
 */
typedef union {
	unsigned long data[10];
	struct {
		unsigned long r0;
		unsigned long r1;
		unsigned long r2;
		unsigned long r3;
		unsigned long r4;
		unsigned long r5;
		unsigned long r6;
		unsigned long sp;
		unsigned long ccr;
		unsigned long pc;
	} name;
} st_task;

/**
 * ֥졼ݥ
 */
struct break_pt {
	volatile unsigned short	*addr;	//!< ɥ쥹
	volatile unsigned short	code;	//!< Υ
};

extern st_task task_reg;	//!< 桼Υ쥸
extern st_task break_reg;	//!< 桼Υ쥸(SCI߻)
extern struct break_pt break_buf[];	//!< ֥졼ݥ

void break_task(void);
unsigned char task_status(void);
void exec_usertask(void);
void step_exec_usertask(void);

void delete_all_breakpoints(void);
void finish_breakpoints(void);
void init_usertask(void);
void init_debuger(void);

#endif // _H_task
