/** @file
 * @brief	ѥ󥰥Хåե
 *
 * @date	2002.03.24
 * @author	Takashi SHUDO
 */

#include "fifo.h"

/**
 * @brief	fifo
 * @param[in] fp	fifo
 * @param[in] buf	fifoȤʤХåեݥ
 * @param[in] size	ХåեΥХȿ
 */
void init_fifo(struct fifo *fp, unsigned char *buf, long size)
{
	fp->buf = buf;
	fp->size = size;
	fp->wp = buf;
	fp->rp = buf;
}

/**
 * @brief fifo˥ǡ񤭹
 * @param[in]	fp	ǡ񤭹ޤfifo
 * @param[in]	data	񤭹ǡ
 * @return	0: 0ʳ:Хåեե
 */
int write_fifo(struct fifo *fp, unsigned char data)
{
	unsigned char	*np;

	np = fp->wp + 1;
	if(np >= &fp->buf[fp->size]) {
		np = fp->buf;
	}

	if(np != fp->rp) {
		*fp->wp = data;
		fp->wp = np;

		return 0;
	} else {
		return -1;	// Хåեե
	}
}

/**
 * @brief fifoǡɤ߽Ф
 * @param[in]	fp	ǡɤ߽Фfifo
 * @param[out]	data	ɤ߽ФǡΥݥ
 * @return	1: 1ʳ:ǡ̵
 */
int read_fifo(struct fifo *fp, unsigned char *data)
{
	unsigned char	*np;

	if(fp->rp != fp->wp) {
		*data = *fp->rp;

		np = fp->rp + 1;
		if(np >= &fp->buf[fp->size]) {
			np = fp->buf;
		}
		fp->rp = np;

		return 1;
	} else {
		return 0;	// Хåեץƥ
	}
}

/**
 * @brief fifo˽񤭹ޤƤǡΥ֤
 * @param[in]	fp	ǡΥɤ߽Фfifo
 * @return	fifo˽񤭹ޤƤǡ
 */
unsigned long fifo_size(struct fifo *fp)
{
	if(fp->wp >= fp->rp) {
		return fp->wp - fp->rp;
	} else {
		return fp->size - (fp->rp - fp->wp);
	}
}
