/** @file
 * @brief	ޥɥҥȥ
 *
 * @date	2007.03.18
 * @author	Takashi SHUDO
 */

#include "history.h"
#include "str.h"

/**
 * @brief	ҥȥ꡼򥯥ꥢ
 * @param[in]	his	ꥢhistory
 */
void init_history(struct history *his)
{
	short i, j;

	for(j=0; j<(MAX_COM_HIS+1); j++) {
		for(i=0; i<(MAX_LINE_COLUMS+1); i++) {
			his->his_buf[j][i] = 0;
		}
	}
	
	his->pos = 0;
	his->num = 0;
}

/**
 * @brief	ҥȥ꡼˥ޥɤϿ
 * @param[in]	his	Ͽhistory
 * @param[in]	com	Ͽ륳ޥʸ
 */
void save_history(struct history *his, char *com)
{
	short i;

	if(strleng(com) != 0) {
		strncopy(his->his_buf[0], com, MAX_LINE_COLUMS);
	
		for(i=MAX_COM_HIS; i>0; i--) {
			strncopy(his->his_buf[i], his->his_buf[i-1],
				 MAX_LINE_COLUMS);
		}
		if(his->num <= MAX_COM_HIS) {
			his->num ++;
		}
		his->pos = 0;
	}
}

/**
 * @brief	Υҥȥ꡼ɽ
 * @param[in]	his	Υҥȥɽhistory
 * @param[out]	le	ҥȥɽlineedit
 */
void foward_history(struct history *his, struct lineedit *le)
{
	if(his->pos > 0) {
		his->pos --;
		set_str_lineedit(le, his->his_buf[his->pos]);
	}
}

/**
 * @brief	Υҥȥ꡼ɽ
 * @param[in]	his	Υҥȥɽhistory
 * @param[out]	le	ҥȥɽlineedit
 */
void back_history(struct history *his, struct lineedit *le)
{
	if((his->pos < MAX_COM_HIS) &&
	   (his->pos < his->num)) {
		if(his->pos == 0) {
			strncopy(his->his_buf[0], le->buf, MAX_LINE_COLUMS);
		}
		
		his->pos ++;

		set_str_lineedit(le, his->his_buf[his->pos]);
	}
}

