/** @file
 * @brief	饤󥨥ǥ
 *
 * @date	2002.03.30
 * @author	Takashi SHUDO
 */

#ifndef	_H_lineedit
#define	_H_lineedit

#include "config.h"

// ҥȥѤλѤ=((MAX_COM_HIS+2) * MAX_LINE_COLUMS)

#define	CTRL_A	0x01
#define	CTRL_B	0x02
#define	CTRL_C	0x03
#define	CTRL_D	0x04
#define	CTRL_E	0x05
#define	CTRL_H	0x08
#define	CTRL_K	0x0b

#define	ESC	0x1b

#define	BS	0x08
#define LF	0x0a
#define	CR	0x0d
#define	XOFF	0x11
#define	XON	0x13

struct lineedit {
	char	buf[MAX_LINE_COLUMS+1];	//!< ԽʸХåե
	short	cur_pos;	//!< 
	char	stat;		//!< ץ󥹾
}; //!< 饤󥨥ǥǡ¤

// do_lineedit()
#define LER_NOP		0	//!< ٥̵
#define LER_RETURN	1	//!< RETUEN
#define LER_BACKLINE	2	//!< Υҥȥ
#define LER_NEXTLINE	3	//!< Υҥȥ

void init_lineedit(struct lineedit *le);
long do_lineedit(struct lineedit *le, char ch);
void new_lineedit(struct lineedit *le);
void set_str_lineedit(struct lineedit *le, char *str);

#endif	// _H_lineedit
