/** @file
 * @brief	h8monᥤ
 *
 * @date	2008.04.28
 * @author	 Takashi SHUDO
 */

/** \mainpage
 *
 * h8monH8/3069ѤΥ˥եȤǤ
 */

#include "vect.h"
#include "str.h"
#include "shell.h"
#include "tprintf.h"
#include "lineedit.h"
#include "stub.h"
#include "task.h"
#include "mon.h"
#include "monio.h"

const extern struct st_monio sci_monio;
const extern struct st_monio stubsci_monio;
extern const struct shell_command mon_com[];
extern int check_application(void);

/**
 * @brief	˥
 */
int main(int argc, char *argv[])
{
	set_monmode(MMODE_MON);
	
	init_debuger();
	
	init_monio(&sci_monio);
	init_stubio(&stubsci_monio);

	print_version();

	init_usertask();
	init_vectortable();
	init_shell(mon_com);

	stub_init();

	if(check_application()) {
		task_reg.name.ccr = 0x00;
		task_reg.name.pc = (INTPOINTER)APP_ADDRESS;
		exec_usertask();
	} else {
		print_prompt();
		mon();
	}
	
	return 0;
}
