/** @file
 * @brief	ޥɥ
 *
 * @date	2007.03.16
 *		2002.03.24
 * @author	Takashi SHUDO
*/

#ifndef	_H_shell
#define	_H_shell

#include "config.h"

// comList.attr ¹ԸΥ꥿Τϻư
#define CMDATTR_CONT	0x0001	// Ʊޥɤ¹
#define CMDATTR_ARGLESS	0x0002	// Ͼά

#define CMDATTR_CTAL	(CMDATTR_CONT|CMDATTR_ARGLESS)

struct shell_command {
	char name[8];
	char sname[4];
	void (*init)(void);
	int (*command)(int argc, char *argv[]);
	unsigned short attr;
	char *help_str;
};

void init_shell(const struct shell_command *coms);
void print_prompt(void);
void dispose_shell_line(void);
int task_shell(char ch);

#endif	/* _H_shell	*/
